Foreman - Bug #5630

VmWare clone from template fails if Network Adator has labels in VmWare
05/08/2014 07:30 AM - Jean-Christophe Counio

Status: Closed
Priority: Normal
Assignee:
Target version: 1.9.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases: 1.5.0
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/2549
Description

In VmWare you can define labels for Network Adapters, and that's the list that is returned in the 'New Host' form 'Network interfaces
list.

In app/models/compute_resources/foreman/model/vmware.rb, in clone_vm, the network adapter is hardcoded as "Network adapter
1"

interface = interfaces.detect{|i| i:name] == "Network adapter 1" }

Since it is not in the interfaces list, clone is failing with error :

Failed to save: Failed to create a compute [...] instance [...]: undefined method “[]' for nil:NilClass
/usr/share/foreman/app/models/compute_resources/foreman/model/vmware.rb:292:in “clone_vm'
/usr/share/foreman/app/models/compute_resources/foreman/model/vmware.rb:257:in “create_vm'

Solution would be to use the selected interface from args instead of having it hardcoded

Related issues:

Related to Foreman - Bug #5483: Network label empty after cloning vware vm us... Closed 04/29/2014
Related to Foreman - Bug #7740: Installing from VMware Image breaks distribut... Closed 09/29/2014
Related to Foreman - Bug #9704: Network label is unchanged on additional netw... Closed 03/10/2015
Related to Foreman - Bug #14874: Path incorrect when using vm_clone method Closed 04/28/2016
Has duplicate Foreman - Support #9956: Failed to create a compute <Datacenter... Resolved 03/31/2015

Associated revisions

Revision e7d21bf0 - 07/16/2015 05:55 AM - Timo Goebel

fixes #5630 - fixes VMWare clone from template fails if VMWare is in foreign language

Revision 73b70677 - 07/17/2015 01:01 PM - Timo Goebel

fixes #5630 - fixes VMWare clone from template fails if VMWare is in foreign language

(cherry picked from commit e7d21bf01f2b9eee19b808c4ea320ddfd9c33b3d)

History

#1 - 05/08/2014 09:04 AM - Dominic Cleal

- Related to Bug #5483: Network label empty after cloning vware vm using image and distributed switch for network added

#2 - 05/08/2014 09:05 AM - Dominic Cleal

- Category set to Compute resources

#3 - 06/20/2014 10:24 AM - Jan Behrend

Our vSphere was once upon a time (ESX3.x) installed in German and the expression for the "Network adapter 1" is then "Netzwerkadapter 1". | am
not suggesting to support all locales at this point but i second Jean-Christophe that this should not be hard coded.

Cheers Jan
#4 - 06/24/2014 08:39 AM - Jan Behrend

Here is another one for hardcoding. For some reason our vSphere has been installed with some german fragments. This is why all of the
deployment features from within foreman did not work:

foreman/app/models/compute_resources/foreman/model/vmware.rb:309
path_replace = %r{/Datacenters/#{datacenter}/vm(/|)}

in german this rather is:
path_replace = %r(/Datencenter/#{datacenter}/vm(/|))

Again, so suggestion to support locales, but hardcoding seems to be causing trouble.

Thanks for all the work!
Cheers Jan

#5 - 07/23/2014 07:06 AM - Dominic Cleal

- Category changed from Compute resources to Compute resources - VMware

#6 - 10/13/2014 08:40 AM - Aaron Zauner

For people experiencing the same issue, this is a (very temporary) fix that seems to work just fine with Foreman 1.6.1:
https://qist.github.com/azet/d55045995d0ef49497¢c5

A generic solution for the issue would be appreciated - but | understand that not many deployments will have this issue.

#7 - 11/11/2014 09:28 AM - Friedrich Seifts
We ran into this issue while trying to setup Foreman against our Vsphere 5.5U1 environment. From what | could tell there was no localization issues
since this install was EN based.

The template we were trying to deploy from was copied over from another data-center(within vcenter).

When we copied the template over it was edited to reference the correct VDS for the new datacenter/network/hyp's it will be servicing. However with
all that said, we still had this issue. When looking at the template when converted to a VM, it showed a single network adapter, but that adapter was
#2 in the list.

What resolve the problem for us was to delete that network adapter, save(click ok), re-add a network adapter and select a default VDS/port-group.
Now the adapter displays as "adapter #1" , instead of "adapter #2" and we are able to deploy VM's.

Cheers.

#8 - 11/11/2014 09:49 AM - Friedrich Seifts

Edit: This was with Foreman 1.6.1

#9 - 11/12/2014 02:16 PM - Friedrich Seifts
- Related to Bug #7740: Installing from VMware Image breaks distributed Port Group support added

#10 - 03/31/2015 03:48 AM - Dominic Cleal

- Has duplicate Support #9956: Failed to create a compute <Datacenter> (VMWare) instance foo.sub.domain.tld: undefined method []' for nil:NilClass
added

#11 - 07/15/2015 04:34 AM - Dominic Cleal

- Related to Bug #9704: Network label is unchanged on additional network interfaces with VMware templates added

#12 - 07/15/2015 04:35 AM - Dominic Cleal

#9704 (which won't be merged for a while) will fix the Network Adapter name lookup, but the Datacenter name.

#13 - 07/15/2015 08:43 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/2549 added
- Pull request deleted ()

#14 - 07/16/2015 05:55 AM - Dominic Cleal

- translation missing: en.field_release set to 35
https://gist.github.com/azet/d55045995d0ef49497c5
https://projects.theforeman.org/issues/2
https://projects.theforeman.org/issues/1
https://projects.theforeman.org/issues/2
https://projects.theforeman.org/issues/9704

#15 - 07/16/2015 06:02 AM - Anonymous
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset e7d21bf01f2b9eee19b808c4ea320ddfd9c33b3d.

#16 - 04/29/2016 04:51 AM - Dominic Cleal
- Related to Bug #14874: Path incorrect when using vm_clone method added
